
#imports zope
from Acquisition import Implicit 
from AccessControl import Owned
from Globals import Persistent
from OFS.SimpleItem import Item, SimpleItem
from AccessControl import ClassSecurityInfo
from Products.PageTemplates.PageTemplateFile import PageTemplateFile
from DateTime import DateTime
from Products.ZCatalog.ZCatalog import ZCatalog

# imports this package
from PloneboardAnyXmlImportTool import ploneboardAnyXmlImportTool
from interfaces import IController
from config import WWWDIR, DEFAULTXMLFILENAME, DEFAULTXSLTFILENAME
from utils import log


class PloneboardAnyXMLImportController(Implicit, Persistent, SimpleItem):

    __implements__ = IController

    meta_type = "PloneboardAnyXMLImportController"
    title = 'PloneboardAnyXMLImportController'

    xmlfile = DEFAULTXMLFILENAME
    xsltfile = DEFAULTXSLTFILENAME

    outputlog = ""

    security = ClassSecurityInfo()

    manage_options = (
        {'label': 'Import!', 'action': 'manage_main'},
        ) + SimpleItem.manage_options

    manage_main = PageTemplateFile('manage_execFormController.zpt', WWWDIR)


    def __init__(self, id, container):
        self.id = id
        self.container = container
        self._mt = ploneboardAnyXmlImportTool(container)
        self.xsltfile = self._mt.getXsltFilename()


    security.declarePublic("migrateFunctionController")
    execFormController = PageTemplateFile('manage_execFormController', WWWDIR )
    def migrateFunctionController(self, xmlfile, xsltfile, displaymode, RESPONSE=None):
        "Changes the product values"
        self._mt = ploneboardAnyXmlImportTool(self.container)
        self.xsltfile = xsltfile
        self.xmlfile = xmlfile
        self._p_changed = 1
        log("abs url: %s; self.container: %s; self._mt.id: %s" %(self.absolute_url(), self.container, self._mt.id) )

        self.migrate(xmlfile, xsltfile, displaymode, False)
        log("migrated ")
        RESPONSE.redirect('%s/manage_main?update_menu=1'
                         % self.absolute_url())


    security.declarePublic("islibxml2libxsltinstalled")
    def islibxml2libxsltinstalled(self):
       return self._mt._islibxml2libxsltinstalled


    security.declarePublic("showresult")
    def showresult(self):
        return self.outputlog


    security.declarePublic("migrate")
    def migrate(self, xmlfilename='example_cmfboardexport.xml', xstlfilename='extractcmfboard.xsl', displayview='threaded_conversation_view', includeconversationintro=False):
        self._mt.addOutput("<br />==== start migration ====")
        self._mt.addOutput("<br />version: %s" %self._mt.version())
        self._mt.addOutput("<br />date &amp; time start: %s" %(DateTime().strftime("%d/%m/%Y %H:%M:%S")) )

        retval = False

        try:
            if self._mt.transformXml(xstlfilename, xmlfilename): 
                self._mt.setViewAsThreaded( displayview == "threaded_conversation_view" )
                if self._mt.migrate():
                    retval = True
        except Exception, e:
            raise
            self._mt.addOutput("<br />an error occurred...: %s" %e)
        self._mt.freeDocs()
        self._mt.addOutput("<br />date &amp; time end: %s" %(DateTime().strftime("%d/%m/%Y %H:%M:%S")) )
        self._mt.addOutput("<br />==== end migration ====<br /<br />")
        self.outputlog = self.outputlog.join(self._mt.getOutput())
        self._p_changed = 1
        #catalog_tool = self.portal.portal_catalog
        #catalog_tool.manage_catalogRebuild()
        #ZCatalog.refreshCatalog()
        return {'success':retval, 'outputtxt':self._mt.getOutput()}


from Globals import InitializeClass
InitializeClass(PloneboardAnyXMLImportController)


# constructors. Only used when the product is added to a folder
addFormController = PageTemplateFile('manage_addFormController', WWWDIR )


def addFunctionController(dispatcher, id, RESPONSE=None):
    """
    	Create a new poll and add it to myself
    """
    p = PloneboardAnyXMLImportController(id, dispatcher.Destination())
    dispatcher.Destination()._setObject(id, p)
    if RESPONSE is not None:
        RESPONSE.redirect('%s/manage_main?update_menu=1'
                         % dispatcher.absolute_url())


