# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

PROJECTNAME = "ploneboard_anyxmlimport"

import os
import logging

try:
    import libxml2
except ImportError:
    HASLIBXML2 = False
    logger = logging.getLogger(PROJECTNAME)
    logger.log(logging.INFO, \
    	'libxml2-python not available.' \
    	' Unable to register libxml2 based marshallers.')
else:
    HASLIBXML2 = True

try:
    from Products.Ploneboard.PloneboardTool import PloneboardTool
except ImportError:
    HASPLONEBOARD = False
else:
    HASPLONEBOARD = True 


from Globals import package_home
product_dir = package_home( globals() )
WWWDIR = os.path.join( product_dir, 'www' )

from utils import makeProductPathAbsolute
f = open( makeProductPathAbsolute("version.txt", None) )
VERSION = f.readline()


DEFAULTXMLFILENAME = "arboco.net_discussies.data" #in subdir inputxml
DEFAULTXSLTFILENAME = "extractcmfboard.xsl" #in subdir xslt
