from Interface import Base

class IController(Base):
    """
        A controller for the migration process from xml data to Ploneboard 
	objects
    """
    
    def islibxml2libxsltinstalled(self):
        """ returns true if libxml2 and libxslt are correctly installed """

    def showresult(self):
        """ get the log file of the migration process """

    def migrate(self, xmlfilename='example_cmfboardexport.xml', xstlfilename='extractcmfboard.xsl', displayview='threaded_conversation_view', includeconversationintro=False):
        """ 
             perform the actual migration.
             Required is to specify the filename of the xml that will be used as
             input for the migration, and if the xml is not in the format as
             the xml export of CMFBoard, specify a xslt as well to transform the
             xml to the format of the internal xml that is used as basis for the
             migration.
             displayview: threaded_conversation_view or conversation_view (the 
                          way how the messages are displayed)
             includeconversationintro: include a part of the first message as the
                          description of the conversation? (Default: False)
 
        """ 