<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xml" version="1.0" encoding="utf-8" indent="yes"/>
<xsl:param name="isdebugmode" value="1" />
<xsl:param name="showcontent" value="1" /> 

<!--Transformation of the export data of cmfboard to a format that is more comfortable to me -->

<xsl:template match="/">
  <forumsroot>
    <xsl:attribute name="name">
      <xsl:value-of select="//ForumFolder/@id"/>
    </xsl:attribute>
    <xsl:attribute name="id">
      <xsl:value-of select="//ForumFolder/@id"/>
    </xsl:attribute>
    <xsl:attribute name="title">
      <xsl:value-of select="//ForumFolder/fields/StringField[@id='title']/string" />
    </xsl:attribute>

  <xsl:apply-templates select="//ForumNB" />
  </forumsroot>
</xsl:template>


<xsl:template match="ForumNB">
  <forum>
    <xsl:attribute name="name">
    	<xsl:value-of select="fields/StringField[@id='title']/string" />
    </xsl:attribute>
    <xsl:attribute name="id">
    	<xsl:value-of select="@id" />
    </xsl:attribute>
    <xsl:attribute name="crdate">
    	<xsl:value-of select="fields/DateTimeField[@id='creation_date']/DateTime" />
    </xsl:attribute>


    <topics>
      <xsl:apply-templates select="topics/ForumTopic" />
    </topics>
  </forum>
</xsl:template>


<xsl:template match="ForumTopic">
   <topic>
     <xsl:attribute name="title">
     	<xsl:value-of select="fields/StringField[@id='title']/string" />
     </xsl:attribute>
     <xsl:attribute name="description">
     	<xsl:value-of select="fields/TextField[@id='description']/string" />
     </xsl:attribute>
     <xsl:attribute name="crdate">
     	<xsl:value-of select="fields/DateTimeField[@id='creation_date']/DateTime" />
     </xsl:attribute>
     <xsl:attribute name="moddate">
     	<xsl:value-of select="fields/DateTimeField[@id='modification_date']/DateTime" />
     </xsl:attribute>
     <xsl:attribute name="creator">
     	<xsl:value-of select="fields/LinesField[@id='creators']/tuple/string" />
     </xsl:attribute>
     <xsl:attribute name="id">
     	<xsl:value-of select="@id" />
     </xsl:attribute>
     <text><xsl:value-of select="fields/TextField[@id='text']/string" /></text>
     <forumpostings>
       <xsl:apply-templates select="children/ForumMessage" />
     </forumpostings>
   </topic>
</xsl:template>


<xsl:template match="ForumMessage">
  <posting>
     <xsl:attribute name="title">
       <xsl:value-of select="fields/StringField[@id='title']/string" />
     </xsl:attribute>
     <xsl:attribute name="description">
       <xsl:value-of select="fields/TextField[@id='description']/string" />
     </xsl:attribute>
     <xsl:attribute name="crdate">
     	<xsl:value-of select="fields/DateTimeField[@id='creation_date']/DateTime" />
     </xsl:attribute>
     <xsl:attribute name="moddate">
     	<xsl:value-of select="fields/DateTimeField[@id='modification_date']/DateTime" />
     </xsl:attribute>
     <xsl:attribute name="creator">
     	<xsl:value-of select="fields/LinesField[@id='creators']/tuple/string" />
     </xsl:attribute>
     <text><xsl:value-of select="fields/TextField[@id='text']/string" /></text>
     <reply_postings>
       <xsl:apply-templates select="children/ForumMessage" />
     </reply_postings>
  </posting>
</xsl:template>





</xsl:stylesheet>